/*****************************************************************************
 * Copyright (c) 2016 Christian W. Damus and others.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Christian W. Damus - Initial API and implementation
 *   
 *****************************************************************************/

package org.eclipse.papyrusrt.umlrt.tooling.diagram.statemachine.internal.editparts;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gmf.runtime.draw2d.ui.figures.IBorderItemLocator;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.papyrus.infra.gmfdiag.common.figure.node.RoundedRectangleNodePlateFigure;
import org.eclipse.papyrus.uml.diagram.statemachine.custom.edit.part.CustomPseudostateEntryPointEditPart;

/**
 * RT specialization of the entry-point edit part.
 */
public class RTPseudostateEntryPointEditPart extends CustomPseudostateEntryPointEditPart implements IRTPseudostateEditPart {

	/**
	 * Initializes me with my notation view.
	 *
	 * @param view
	 *            my notation view
	 */
	public RTPseudostateEntryPointEditPart(View view) {
		super(view);
	}

	@Override
	protected NodeFigure createNodePlate() {
		Dimension defaultSize = getDefaultSize();
		RoundedRectangleNodePlateFigure result = new RoundedRectangleNodePlateFigure(defaultSize.width(), defaultSize.height());
		return result;
	}

	@Override
	protected void refreshBounds() {
		super.refreshBounds();

		IBorderItemLocator locator = getBorderItemLocator();
		if (locator != null) {
			locator.relocate(getFigure());
		}
	}
}
